Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3069)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3083)
@@ -25,4 +25,25 @@
 ! -----------------
 ! $Id$
+! - set limits of diss at the end of prognostic equations
+! - call production_e to calculate production term of diss
+! - limit change of diss to -90% to +100%
+! - remove factor 0.5 from diffusion_diss_ij
+! - rename c_m into c_0, and c_h into c_4
+! - add rans_const_c and rans_const_sigma as namelist parameters
+! - add calculation of mixing length for profile output in case of rans_tke_e
+! - changed format of annotations to comply with doxygen standards
+! - calculate and save dissipation rate during rans_tke_l mode
+! - set bc at vertical walls for e, diss, km, kh
+! - bugfix: set l_wall = 0.0 within buildings
+! - set l_wall at bottom and top boundary (rans-mode)
+! - bugfix in production term for dissipation rate
+! - bugfix in diffusion of dissipation rate
+! - disable check for 1D model if rans_tke_e is used
+! - bugfixes for initialization (rans-mode):
+!    - correction of dissipation-rate formula
+!    - calculate km based on l_wall
+!    - initialize diss if 1D model is not used
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error message revised
 ! 
@@ -36,5 +57,5 @@
 ! Further todo's
 ! 
-! 2936 2018-03-27 14:49:27Z suehring
+! 2936 2018-03-27 14:49:27Z gronemeier
 ! - defined l_grid only within this module
 ! - Moved l_wall definition from modules.f90
@@ -81,5 +102,4 @@
 !>       add OpenMP directives whereever possible
 !>       remove debug output variables (dummy1, dummy2, dummy3)
-!> @todo Move initialization of wall-mixing length from init_grid
 !> @todo Check for random disturbances
 !> @note <Enter notes on the module>
@@ -146,15 +166,20 @@
 
 
-    REAL(wp) ::  c_1  = 1.44_wp    !< model constant for RANS mode
-    REAL(wp) ::  c_2  = 1.92_wp    !< model constant for RANS mode
-    REAL(wp) ::  c_3  = 1.44_wp    !< model constant for RANS mode
-    REAL(wp) ::  c_h  = 0.0015_wp  !< model constant for RANS mode
-    REAL(wp) ::  c_m               !< constant used for diffusion coefficient and dissipation (dependent on mode RANS/LES)
-    REAL(wp) ::  c_mu = 0.09_wp    !< model constant for RANS mode
-    REAL(wp) ::  l_max             !< maximum length scale for Blackadar mixing length
-    REAL(wp) ::  sig_e = 1.0_wp    !< factor to calculate Ke from Km
-    REAL(wp) ::  sig_diss = 1.3_wp !< factor to calculate K_diss from Km
-    INTEGER(iwp) ::  surf_e        !< end index of surface elements at given i-j position
-    INTEGER(iwp) ::  surf_s        !< start index of surface elements at given i-j position
+    REAL(wp) ::  c_0                !< constant used for diffusion coefficient and dissipation (dependent on mode RANS/LES)
+    REAL(wp) ::  c_1                !< model constant for RANS mode
+    REAL(wp) ::  c_2                !< model constant for RANS mode
+    REAL(wp) ::  c_3                !< model constant for RANS mode
+    REAL(wp) ::  c_4                !< model constant for RANS mode
+    REAL(wp) ::  l_max              !< maximum length scale for Blackadar mixing length
+    REAL(wp) ::  dsig_e = 1.0_wp    !< factor to calculate Ke from Km (1/sigma_e)
+    REAL(wp) ::  dsig_diss = 1.0_wp !< factor to calculate K_diss from Km (1/sigma_diss)
+    INTEGER(iwp) ::  surf_e         !< end index of surface elements at given i-j position
+    INTEGER(iwp) ::  surf_s         !< start index of surface elements at given i-j position
+
+    REAL(wp), DIMENSION(0:4) :: rans_const_c = &       !< model constants for RANS mode (namelist param)
+       (/ 0.55_wp, 1.44_wp, 1.92_wp, 0.0_wp, 0.0_wp /) !> default values fit for standard-tke-e closure
+
+    REAL(wp), DIMENSION(2) :: rans_const_sigma = &     !< model constants for RANS mode, sigma values (sigma_e, sigma_diss) (namelist param)
+       (/ 1.0_wp, 0.77_wp /)
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_black    !< mixing length according to Blackadar
@@ -163,10 +188,12 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  l_wall !< near-wall mixing length
 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: dummy1 !< debug output variable
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: dummy2 !< debug output variable
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: dummy3 !< debug output variable
-
-
-    PUBLIC c_m, dummy1, dummy2, dummy3
+    !> @todo remove debug variables
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: diss_prod1, diss_adve1, diss_diff1, &
+                                               diss_prod2, diss_adve2, diss_diff2, &
+                                               diss_prod3, diss_adve3, diss_diff3, &
+                                               dummy1, dummy2, dummy3
+
+
+    PUBLIC c_0, rans_const_c, rans_const_sigma
 
 !
@@ -294,4 +321,9 @@
 ! ------------
 !> Check parameters routine for turbulence closure module.
+!> @todo remove rans_mode from initialization namelist and rework checks
+!>   The way it is implemented at the moment, the user has to set two variables
+!>   so that the RANS mode is working. It would be better if only one parameter
+!>   has to be set.
+!>   2018-06-18, gronemeier
 !------------------------------------------------------------------------------!
  SUBROUTINE tcm_check_parameters
@@ -307,5 +339,14 @@
     IF ( rans_mode )  THEN
 
-       c_m = 0.4_wp  !according to Detering and Etling (1985)
+!
+!--    Assign values to constants for RANS mode
+       dsig_e    = 1.0_wp / rans_const_sigma(1)
+       dsig_diss = 1.0_wp / rans_const_sigma(2)
+
+       c_0 = rans_const_c(0)
+       c_1 = rans_const_c(1)
+       c_2 = rans_const_c(2)
+       !c_3 = rans_const_c(3)   !> @todo clarify how to switch between different models
+       c_4 = rans_const_c(4)
 
        SELECT CASE ( TRIM( turbulence_closure ) )
@@ -316,28 +357,29 @@
           CASE ( 'TKE-e' )
              rans_tke_e = .TRUE.
-
-             IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) == 0  &
-                  .AND.  .NOT.  nest_domain )  THEN
-                message_string = 'Initializing without 1D model while ' //     &
-                                 'using TKE-e closure&' //                     &
-                                 'is not possible at the moment!'
-                CALL message( 'tcm_check_parameters', 'TG0005', 1, 2, 0, 6, 0 )
-             ENDIF
 
           CASE DEFAULT
              message_string = 'Unknown turbulence closure: ' //                &
                               TRIM( turbulence_closure )
-             CALL message( 'tcm_check_parameters', 'TG0001', 1, 2, 0, 6, 0 )
+             CALL message( 'tcm_check_parameters', 'PA0500', 1, 2, 0, 6, 0 )
 
        END SELECT
+
+       IF ( turbulent_inflow .OR. turbulent_outflow )  THEN
+          message_string = 'turbulent inflow/outflow is not yet '//            &
+                           'implemented for RANS mode'
+          CALL message( 'tcm_check_parameters', 'PA0501', 1, 2, 0, 6, 0 )
+       ENDIF
 
        message_string = 'RANS mode is still in development! ' //               &
                         '&Not all features of PALM are yet compatible '//      &
                         'with RANS mode. &Use at own risk!'
-       CALL message( 'tcm_check_parameters', 'TG0003', 0, 1, 0, 6, 0 )
+       CALL message( 'tcm_check_parameters', 'PA0502', 0, 1, 0, 6, 0 )
 
     ELSE
 
-       c_m = 0.1_wp !according to Lilly (1967) and Deardorff (1980)
+       c_0 = 0.1_wp !according to Lilly (1967) and Deardorff (1980)
+
+       dsig_e = 1.0_wp !assure to use K_m to calculate TKE instead 
+                       !of K_e which is used in RANS mode
 
        SELECT CASE ( TRIM( turbulence_closure ) )
@@ -347,19 +389,10 @@
 
           CASE DEFAULT
+             !> @todo rework this part so that only one call of this error exists
              message_string = 'Unknown turbulence closure: ' //                &
                               TRIM( turbulence_closure )
-             CALL message( 'tcm_check_parameters', 'TG0001', 1, 2, 0, 6, 0 )
+             CALL message( 'tcm_check_parameters', 'PA0500', 1, 2, 0, 6, 0 )
 
        END SELECT
-
-    ENDIF
-
-    IF ( rans_tke_e )  THEN
-
-       IF ( turbulent_inflow .OR. turbulent_outflow )  THEN
-          message_string = 'turbulent inflow/outflow is not yet '//            &
-                           'implemented for TKE-e closure'
-          CALL message( 'tcm_check_parameters', 'TG0002', 1, 2, 0, 6, 0 )
-       ENDIF
 
     ENDIF
@@ -379,23 +412,21 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  unit     !< 
-    CHARACTER (LEN=*) ::  var      !<
-
-    INTEGER(iwp) ::  i      !<
-    INTEGER(iwp) ::  ilen   !<
-    INTEGER(iwp) ::  k      !<
+    CHARACTER (LEN=*) ::  unit     !< unit of output variable
+    CHARACTER (LEN=*) ::  var      !< name of output variable
+
+    INTEGER(iwp) ::  i      !< index of var in data_output
+    INTEGER(iwp) ::  ilen   !< length of var string
+    INTEGER(iwp) ::  k      !< flag if var contains one of '_xy', '_xz' or '_yz'
 
     SELECT CASE ( TRIM( var ) )
 
        CASE ( 'diss' )
-          IF ( .NOT.  rans_tke_e )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                      'res TKE-e closure for RANS mode.'
-             CALL message( 'tcm_check_data_output', 'TG0101', 1, 2, 0, 6, 0 )
-          ENDIF
           unit = 'm2/s3'
 
-       CASE ( 'dummy2', 'dummy3', 'dummy1' )
-          unit = 'mixing length'
+       CASE ( 'diss1', 'diss2',                         &                      !> @todo remove later
+              'diss_prod1', 'diss_adve1', 'diss_diff1', &
+              'diss_prod2', 'diss_adve2', 'diss_diff2', &
+              'diss_prod3', 'diss_adve3', 'diss_diff3', 'dummy3'  )
+          unit = 'debug output'
 
        CASE ( 'kh', 'km' )
@@ -420,11 +451,11 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_x   !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_y   !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_z   !< 
-    CHARACTER (LEN=*), INTENT(IN)  ::  var      !<
-    
-    LOGICAL, INTENT(OUT) ::  found   !<
-    
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_x   !< x grid of output variable
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_y   !< y grid of output variable
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_z   !< z grid of output variable
+    CHARACTER (LEN=*), INTENT(IN)  ::  var      !< name of output variable
+
+    LOGICAL, INTENT(OUT) ::  found   !< flag if output variable is found
+
     found  = .TRUE.
 
@@ -438,5 +469,8 @@
           grid_z = 'zu'
 
-       CASE ( 'dummy2', 'dummy3', 'dummy1' )                                    !### remove later
+       CASE ( 'diss1', 'diss2',                         &                       !> @todo remove later
+              'diss_prod1', 'diss_adve1', 'diss_diff1', &
+              'diss_prod2', 'diss_adve2', 'diss_diff2', &
+              'diss_prod3', 'diss_adve3', 'diss_diff3', 'dummy3' )
           grid_x = 'x'
           grid_y = 'y'
@@ -480,10 +514,10 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode       !< 
-    CHARACTER (LEN=*) ::  variable   !< 
-
-    INTEGER(iwp) ::  i   !< 
-    INTEGER(iwp) ::  j   !< 
-    INTEGER(iwp) ::  k   !< 
+    CHARACTER (LEN=*) ::  mode       !< flag defining mode 'allocate', 'sum' or 'average'
+    CHARACTER (LEN=*) ::  variable   !< name of variable
+
+    INTEGER(iwp) ::  i   !< loop index
+    INTEGER(iwp) ::  j   !< loop index
+    INTEGER(iwp) ::  k   !< loop index
 
     IF ( mode == 'allocate' )  THEN
@@ -616,16 +650,16 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  grid       !< 
-    CHARACTER (LEN=*) ::  mode       !< 
-    CHARACTER (LEN=*) ::  variable   !< 
-
-    INTEGER(iwp) ::  av   !< 
-    INTEGER(iwp) ::  i    !< 
-    INTEGER(iwp) ::  j    !< 
-    INTEGER(iwp) ::  k    !< 
-    INTEGER(iwp) ::  nzb_do   !< 
-    INTEGER(iwp) ::  nzt_do   !< 
-
-    LOGICAL ::  found   !< 
+    CHARACTER (LEN=*) ::  grid       !< name of vertical grid
+    CHARACTER (LEN=*) ::  mode       !< either 'xy', 'xz' or 'yz'
+    CHARACTER (LEN=*) ::  variable   !< name of variable
+
+    INTEGER(iwp) ::  av   !< flag for (non-)average output
+    INTEGER(iwp) ::  i    !< loop index
+    INTEGER(iwp) ::  j    !< loop index
+    INTEGER(iwp) ::  k    !< loop index
+    INTEGER(iwp) ::  nzb_do   !< vertical output index (bottom)
+    INTEGER(iwp) ::  nzt_do   !< vertical output index (top)
+
+    LOGICAL ::  found   !< flag if output variable is found
     LOGICAL ::  two_d   !< flag parameter that indicates 2D variables (horizontal cross sections)
 
@@ -737,14 +771,14 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  variable   !< 
-
-    INTEGER(iwp) ::  av     !< 
-    INTEGER(iwp) ::  i      !< 
-    INTEGER(iwp) ::  j      !< 
-    INTEGER(iwp) ::  k      !< 
+    CHARACTER (LEN=*) ::  variable   !< name of variable
+
+    INTEGER(iwp) ::  av     !< flag for (non-)average output
+    INTEGER(iwp) ::  i      !< loop index
+    INTEGER(iwp) ::  j      !< loop index
+    INTEGER(iwp) ::  k      !< loop index
     INTEGER(iwp) ::  nzb_do !< lower limit of the data output (usually 0)
     INTEGER(iwp) ::  nzt_do !< vertical upper limit of the data output (usually nz_do3d)
 
-    LOGICAL ::  found   !< 
+    LOGICAL ::  found   !< flag if output variable is found
 
     REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
@@ -829,5 +863,16 @@
           ENDIF
 
-       CASE ( 'dummy1' )                                                        !### remove later
+       CASE ( 'dummy3' )                                                        !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = dummy3(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss1' )                                                         !> @todo remove later
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -840,5 +885,5 @@
           ENDIF
 
-       CASE ( 'dummy2' )                                                        !### remove later
+       CASE ( 'diss2' )                                                         !> @todo remove later
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -851,10 +896,10 @@
           ENDIF
 
-       CASE ( 'dummy3' )                                                        !### remove later
+       CASE ( 'diss_prod1' )                                                    !> @todo remove later
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
                 DO  j = nys, nyn
                    DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = dummy3(k,j,i)
+                      local_pf(i,j,k) = diss_prod1(k,j,i)
                    ENDDO
                 ENDDO
@@ -862,4 +907,92 @@
           ENDIF
 
+       CASE ( 'diss_adve1' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_adve1(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_diff1' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_diff1(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_prod2' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_prod2(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_adve2' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_adve2(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_diff2' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_diff2(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_prod3' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_prod3(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_adve3' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_adve3(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       CASE ( 'diss_diff3' )                                                    !> @todo remove later
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do
+                      local_pf(i,j,k) = diss_diff3(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+          
        CASE DEFAULT
           found = .FALSE.
@@ -891,9 +1024,28 @@
     ALLOCATE( km(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
-    ALLOCATE( dummy1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )                           !### remove later
+    ALLOCATE( dummy1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )                           !> @todo remove later
     ALLOCATE( dummy2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ALLOCATE( dummy3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
-    IF ( rans_mode )  ALLOCATE( l_black(nzb:nzt+1) )
+    ALLOCATE( diss_adve1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_adve2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_adve3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_prod1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_prod2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_prod3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_diff1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_diff2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( diss_diff3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    dummy1 = 0.0_wp
+    dummy2 = 0.0_wp
+    dummy3 = 0.0_wp
+    diss_adve1 = 0.0_wp
+    diss_adve2 = 0.0_wp
+    diss_adve3 = 0.0_wp
+    diss_prod1 = 0.0_wp
+    diss_prod2 = 0.0_wp
+    diss_prod3 = 0.0_wp
+    diss_diff1 = 0.0_wp
+    diss_diff2 = 0.0_wp
+    diss_diff3 = 0.0_wp
 
 #if defined( __nopointer )
@@ -912,5 +1064,5 @@
 !-- they do not necessarily need to be transferred, which is attributed to 
 !-- the design of the model coupler which allocates memory for each variable. 
-    IF ( rans_tke_e  .OR.  use_sgs_for_particles  .OR.  wang_kernel  .OR.      &
+    IF ( rans_mode  .OR.  use_sgs_for_particles  .OR.  wang_kernel  .OR.       &
          collision_turbulence  .OR.  nested_run )  THEN
 #if defined( __nopointer )
@@ -934,5 +1086,5 @@
     e  => e_1;   e_p  => e_2;   te_m  => e_3
 
-    IF ( rans_tke_e  .OR.  use_sgs_for_particles  .OR.     &
+    IF ( rans_mode  .OR.  use_sgs_for_particles  .OR.     &
          wang_kernel  .OR.  collision_turbulence  .OR.  nested_run )  THEN
        diss => diss_1
@@ -967,10 +1119,11 @@
     INTEGER(iwp) :: j            !< loop index
     INTEGER(iwp) :: k            !< loop index
-    INTEGER(iwp) :: nz_s_shift   !<
-    INTEGER(iwp) :: nz_s_shift_l !< 
+    INTEGER(iwp) :: nz_s_shift   !< lower shift index for scalars
+    INTEGER(iwp) :: nz_s_shift_l !< local lower shift index in case of turbulent inflow
 
 !
 !-- Initialize mixing length
     CALL tcm_init_mixing_length
+    dummy3 = l_wall                 !> @todo remove later
 
 !
@@ -995,7 +1148,7 @@
 
           IF ( rans_tke_e )  THEN
-             IF ( dissipation_1d == 'prognostic' )  THEN    !### Why must this be checked?
-                DO  i = nxlg, nxrg                          !### Should 'diss' not always
-                   DO  j = nysg, nyng                       !### be prognostic in case rans_tke_e?
+             IF ( dissipation_1d == 'prognostic' )  THEN    !> @query Why must this be checked?
+                DO  i = nxlg, nxrg                          !>   Should 'diss' not always
+                   DO  j = nysg, nyng                       !>   be prognostic in case rans_tke_e?
                       diss(:,j,i) = diss1d
                    ENDDO
@@ -1005,5 +1158,5 @@
                    DO  j = nysg, nyng
                       DO  k = nzb+1, nzt
-                         diss(k,j,i) = e(k,j,i) * SQRT( e(k,j,i) ) / l1d(k)
+                         diss(k,j,i) = c_0**4 * e(k,j,i)**2 / km1d(k)
                       ENDDO
                    ENDDO
@@ -1016,15 +1169,19 @@
 
           IF ( constant_diffusion )  THEN
-             km   = km_constant
-             kh   = km / prandtl_number
-             e    = 0.0_wp
+             km = km_constant
+             kh = km / prandtl_number
+             e  = 0.0_wp
           ELSEIF ( e_init > 0.0_wp )  THEN
-             DO  k = nzb+1, nzt
-                km(k,:,:) = c_m * l_grid(k) * SQRT( e_init )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb+1, nzt
+                      km(k,j,i) = c_0 * l_wall(k,j,i) * SQRT( e_init )
+                   ENDDO
+                ENDDO
              ENDDO
              km(nzb,:,:)   = km(nzb+1,:,:)
              km(nzt+1,:,:) = km(nzt,:,:)
-             kh   = km / prandtl_number
-             e    = e_init
+             kh = km / prandtl_number
+             e  = e_init
           ELSE
              IF ( .NOT. ocean )  THEN
@@ -1040,4 +1197,16 @@
           ENDIF
 
+          IF ( rans_tke_e )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb+1, nzt
+                      diss(k,j,i) = c_0**4 * e(k,j,i)**2 / km(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+             diss(nzb,:,:) = diss(nzb+1,:,:)
+             diss(nzt+1,:,:) = diss(nzt,:,:)
+          ENDIF
+
        ENDIF
 !
@@ -1073,4 +1242,13 @@
              ENDDO
           ENDDO
+          IF ( rans_tke_e )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   nz_s_shift = get_topography_top_index_ji( j, i, 's' )
+
+                   diss(nz_s_shift:nzt+1,j,i) = diss(0:nzt+1-nz_s_shift,j,i)
+                ENDDO
+             ENDDO
+          ENDIF
        ENDIF
 
@@ -1084,5 +1262,6 @@
 !--       boundary and adjust mean inflow profiles
           IF ( complex_terrain )  THEN
-             IF ( nxlg <= 0 .AND. nxrg >= 0 .AND. nysg <= 0 .AND. nyng >= 0 )  THEN
+             IF ( nxlg <= 0 .AND. nxrg >= 0 .AND.  &
+                  nysg <= 0 .AND. nyng >= 0        )  THEN
                 nz_s_shift_l = get_topography_top_index_ji( 0, 0, 's' )
              ELSE
@@ -1095,5 +1274,6 @@
              nz_s_shift = nz_s_shift_l
 #endif
-             mean_inflow_profiles(nz_s_shift:nzt+1,5) = hom_sum(0:nzt+1-nz_s_shift,8,0)  ! e
+             mean_inflow_profiles(nz_s_shift:nzt+1,5) =  &
+                hom_sum(0:nzt+1-nz_s_shift,8,0)  ! e
           ENDIF
 !
@@ -1114,5 +1294,5 @@
 !
 !--       Inside buildings set TKE back to zero.
-!--       Other scalars (km, kh, diss, ...) are ignored at present,
+!--       Other scalars (km, kh,...) are ignored at present,
 !--       maybe revise later.
           DO  i = nxlg, nxrg
@@ -1121,10 +1301,18 @@
                    e(k,j,i)     = MERGE( e(k,j,i), 0.0_wp,                     &
                                          BTEST( wall_flags_0(k,j,i), 0 ) )
-                   te_m(k,j,i)  = MERGE( te_m(k,j,i), 0.0_wp,                  &
-                                         BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDDO
              ENDDO
           ENDDO
 
+          IF ( rans_tke_e )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt
+                      diss(k,j,i)    = MERGE( diss(k,j,i), 0.0_wp,             &
+                                              BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
        ENDIF
 !
@@ -1134,7 +1322,12 @@
 !
 !--    Allthough tendency arrays are set in prognostic_equations, they have
-!--    have to be predefined here because they are used (but multiplied with 0)
-!--    there before they are set. 
+!--    to be predefined here because there they are used (but multiplied with 0)
+!--    before they are set.
        te_m = 0.0_wp
+
+       IF ( rans_tke_e )  THEN
+          diss_p = diss
+          tdiss_m = 0.0_wp
+       ENDIF
 
     ENDIF
@@ -1215,11 +1408,11 @@
 
        DO  k = 1, nzt
-          IF ( l_grid(k) > 1.5_wp * dx * wall_adjustment_factor .OR.           &
+          IF ( l_grid(k) > 1.5_wp * dx * wall_adjustment_factor .OR.            &
                l_grid(k) > 1.5_wp * dy * wall_adjustment_factor )  THEN
-             WRITE( message_string, * ) 'grid anisotropy exceeds ',            &
-                                        'threshold given by only local',       &
-                                        ' horizontal reduction of near_wall ', &
-                                        'mixing length l_wall',                &
-                                        ' starting from height level k = ', k, &
+             WRITE( message_string, * ) 'grid anisotropy exceeds ',             &
+                                        'threshold given by only local',        &
+                                        ' &horizontal reduction of near_wall ', &
+                                        'mixing length l_wall',                 &
+                                        ' &starting from height level k = ', k, &
                                         '.'
              CALL message( 'init_grid', 'PA0202', 0, 1, 0, 6, 0 )
@@ -1320,10 +1513,11 @@
 !
 !-- Initialize the mixing length in case of a RANS simulation
+       ALLOCATE( l_black(nzb:nzt+1) )
 
 !
 !--    Calculate mixing length according to Blackadar (1962)
        IF ( f /= 0.0_wp )  THEN
-          l_max = 2.7E-4 * SQRT( ug(nzt+1)**2 + vg(nzt+1)**2 ) /               &
-                  ABS( f ) + 1E-10_wp
+          l_max = 2.7E-4_wp * SQRT( ug(nzt+1)**2 + vg(nzt+1)**2 ) /            &
+                  ABS( f ) + 1.0E-10_wp
        ELSE
           l_max = 30.0_wp
@@ -1338,11 +1532,11 @@
 !
 !--    Gather topography information of whole domain
-       !## TODO: reduce amount of data sent by MPI call
-       !##  By now, a whole global 3D-array is sent and received with
-       !##  MPI_ALLREDUCE although most of the array is 0. This can be
-       !##  drastically reduced if only the local subarray is sent and stored
-       !##  in a global array. For that, an MPI data type or subarray must be
-       !##  defined.
-       !##  2018-03-19, gronemeier
+       !> @todo reduce amount of data sent by MPI call
+       !>   By now, a whole global 3D-array is sent and received with
+       !>   MPI_ALLREDUCE although most of the array is 0. This can be
+       !>   drastically reduced if only the local subarray is sent and stored
+       !>   in a global array. For that, an MPI data type or subarray must be
+       !>   defined.
+       !>   2018-03-19, gronemeier
        ALLOCATE( wall_flags_0_global(nzb:nzt+1,0:ny,0:nx) )
 
@@ -1373,4 +1567,7 @@
           ENDDO
        ENDDO
+
+       l_wall(nzb,:,:) = l_black(nzb)
+       l_wall(nzt+1,:,:) = l_black(nzt+1)
 !
 !--    Limit mixing length to either nearest wall or Blackadar mixing length.
@@ -1415,10 +1612,10 @@
           IF ( rad_k_b /= 0 .OR. rad_k_t /= 0 )  THEN
 
-             !## NOTE: shape of vicinity is larger in z direction
-             !##  Shape of vicinity is two grid points larger than actual search
-             !##  radius in vertical direction. The first and last grid point is
-             !##   always set to 1 to asure correct detection of topography. See
-             !##  function "shortest_distance" for details.
-             !##  2018-03-16, gronemeier
+             !> @note shape of vicinity is larger in z direction
+             !>   Shape of vicinity is two grid points larger than actual search
+             !>   radius in vertical direction. The first and last grid point is
+             !>   always set to 1 to asure correct detection of topography. See
+             !>   function "shortest_distance" for details.
+             !>   2018-03-16, gronemeier
              ALLOCATE( vicinity(-rad_k-1:rad_k+1,-rad_j:rad_j,-rad_i:rad_i) )
              ALLOCATE( vic_yz(0:rad_k+1,0:rad_j) )
@@ -1601,5 +1798,5 @@
                    ELSE  !Check if (i,j,k) belongs to atmosphere
 
-                      l_wall(k,j,i) = -999.0
+                      l_wall(k,j,i) = l_black(k)
 
                    ENDIF
@@ -1630,4 +1827,6 @@
 !> (pos_i/jj/kk), where (jj/kk) is the position of the maximum of 'array'
 !> closest to the origin (0/0) of 'array'.
+!> @todo this part of PALM does not reproduce the same results for optimized
+!>   and debug options for the compiler. This should be fixed
 !------------------------------------------------------------------------------!
     REAL FUNCTION shortest_distance( array, orientation, pos_i )
